###G: graph edges (first vertex is 1) 

###load functions for all examples (sometimes needs to load it twice): 

#read "graph2perMatrix.mpl";

###use graph2perMatrix for a given fixed K_d, graph2allBezout_2d for all mBezout of Laman graphs or graph2allBezout_3d for all mBezout of Geiringer graphs
###uncomment input-functions

##matrix for permanent:
##A:=graph2perMatrix(n,G,d,fixed):
#with(LinearAlgebra):
##Permanent(A)*(2/(factorial(d)))^(n-d);

###mBezout for all choices of fixed K_2  (d=2)
##graph2allBezout_2d(n, G) ;

###mBezout for all choices of fixed K_3  (d=3)
##graph2allBezout_3d(n, G) ;

###2-dimensional examples

#d:=2:

##Desargues
#n:=6:
#G := [[1,2],[1, 3], [1, 4], [2, 3], [2, 5], [3, 6], [4, 5], [4, 6], [5, 6]]:
#fixed:=[1,2]:

#A:=graph2perMatrix(n,G,2,fixed):
#with(LinearAlgebra):
#Permanent(A);

#graph2allBezout_2d(n, G) ;

##L56
#n:=7:
#G:=[[1, 2], [1, 5], [1, 6], [2, 3], [2, 4], [3, 6], [3, 7], [4, 5], [4, 7], [5, 7],[6,7]]:
#fixed:=[6,7]:

#A:=graph2perMatrix(n,G,2,fixed):
#with(LinearAlgebra):
#Permanent(A);

#graph2allBezout_2d(n, G) ;


##L136
#n:=8:
#G:=[[1, 2], [1, 4], [1, 8], [2, 3], [2, 7], [3, 6], [3, 8],  [4,5],[4, 7], [5, 7], [5, 8], [6, 7], [6, 8]]:
#fixed:=[4,5]:

#A:=graph2perMatrix(n,G,2,fixed):
#with(LinearAlgebra):
#Permanent(A);

#graph2allBezout_2d(n, G) ;

##Jackson-Owen
#n:=8:
#G:=[[1, 2], [1, 4], [1,5],[1, 7], [2, 3], [2, 6], [3, 4], [3, 7],  [4, 8], [5, 6], [5, 8], [6, 7], [7, 8]]:
#fixed:=[1,2]:

#A:=graph2perMatrix(n,G,2,fixed):
#with(LinearAlgebra):
#Permanent(A);

#graph2allBezout_2d(n, G) ;


#n:=9:
#G:=[[1, 4], [1, 6], [1, 9], [2, 3], [2, 5], [2, 8], [3, 7], [3, 9], [4, 7], [4, 9], [5, 7], [5, 8], [6, 7], [6, 8],[8,9]]:
#fixed:=[8,9]:

#A:=graph2perMatrix(n,G,2,fixed):
#with(LinearAlgebra):
#Permanent(A);

#graph2allBezout_2d(n, G) ;



#n:=10:
#G:=[[1, 4], [1, 8], [1, 10], [2, 3], [2, 7], [2, 10], [3, 7], [3, 9], [4, 8], [4, 9], [5, 7], [5, 8], [5, 10], [6, 7], [6, 8], [6, 9],[9,10]]:
#fixed:=[9,10]:

#A:=graph2perMatrix(n,G,2,fixed):
#with(LinearAlgebra):
#Permanent(A);

#graph2allBezout_2d(n, G) ;

#n:=11:
#G:=[[1, 2], [1, 10], [1, 11], [2, 8], [2, 9], [3, 7], [3, 9], [3, 10], [4, 7], [4, 10], [4, 11], [5, 7], [5, 8], [5, 9], [6, 7],[6,8],  [6, 11], [8, 11], [9, 10]]:
#fixed:=[6,8]:

#A:=graph2perMatrix(n,G,2,fixed):
#with(LinearAlgebra):
#Permanent(A);

#graph2allBezout_2d(n, G) ;



#n:=12:
#G:=[[1, 10], [1, 11], [1, 12], [2, 9], [2, 11], [2, 12], [3, 8], [3, 10], [3, 12], [4, 7], [4, 9], [4, 11], [5, 7], [5, 8], [5, 10], [6, 7],[6,8],  [6, 9], [7, 12], [8, 11], [9, 10]]:
#fixed:=[6,8]:

#A:=graph2perMatrix(n,G,2,fixed):
#with(LinearAlgebra):
#Permanent(A);

#graph2allBezout_2d(n, G) ;

#n:=18:
#G:=[[1, 15], [1, 16], [1, 18], [2, 15], [2, 16], [2, 17], [3, 12], [3, 13],[3, 18], [4, 11], [4, 14], [4, 17], [5, 8], [5,9],[5, 10], [5, 14], [6, 7], [6, 13], [7, 12], [7, 14], [7, 18], [8, 11],[8, 13], [8, 17], [9, 10], [9, 11], [9, 16], [10, 12], [10, 15], [11, 18], [12, 17], [13, 15], [14, 16]]:
#fixed:=[5,9]:

#A:=graph2perMatrix(n,G,2,fixed):
#with(LinearAlgebra):
#Permanent(A);

#graph2allBezout_2d(n, G) ;



##3-dimensional examples
#d:=3:

#n:=6:
#G:=[[1, 2], [1, 3], [1,4],[1,5],[2, 3],  [2, 5], [2, 6], [3, 4], [3, 6], [4, 5], [4, 6],[5,6]]:
#fixed:=[1,2,3]:

#A:=graph2perMatrix(n,G,3,fixed):
#with(LinearAlgebra):
#Permanent(A)*(1/3)^(n-3);

#graph2allBezout_3d(n, G) ;


##G48
#n:=7:
#G:=[[1, 4], [1,5],[1,6], [1, 7], [2, 3], [2, 5], [2, 6], [2, 7], [3, 4], [3, 6], [3, 7], [4, 6], [4, 7],  [5,6], [5, 7]]:
#fixed:=[1,5,6]:

#A:=graph2perMatrix(n,G,3,fixed):
#with(LinearAlgebra):
#Permanent(A)*(1/3)^(n-3);

#graph2allBezout_3d(n, G) ;

#n:=8:
#G:=[[1, 4], [1, 6], [1, 7], [1, 8],  [2,3] ,[2,5], [2, 6], [2, 8], [3,5], [3, 6], [3, 7], [4, 5], [4, 7], [4, 8], [5, 7], [5, 8], [6, 7], [6, 8]]:
#fixed:=[2,3,5]:

#A:=graph2perMatrix(n,G,3,fixed):
#with(LinearAlgebra):
#Permanent(A)*(1/3)^(n-3);

#graph2allBezout_3d(n, G) ;


#n:=9:
#G:=[[1, 5], [1, 6], [1, 8], [1, 9],  [2,4],[2, 6], [2, 7], [2, 8] , [3, 4], [3, 5], [3, 7], [3, 9], [4, 7], [4,8], [4, 9], [5, 6], [5, 7], [5, 9], [6, 7], [6, 8], [8, 9]]:
#fixed:=[2,4,8]:

#A:=graph2perMatrix(n,G,3,fixed):
#with(LinearAlgebra):
#Permanent(A)*(1/3)^(n-3);

#graph2allBezout_3d(n, G) ;

#n:=10:
#G:=[[1, 5], [1, 6], [1, 9], [1, 10], [2, 3], [2, 4], [2, 7], [2, 8], [3, 7], [3, 8], [3, 9], [3, 10], [4, 5], [4, 6], [4, 7], [4, 8], [5, 6], [5, 8], [5, 10], [6,7],[6,9], [7,9], [8, 10], [9, 10]]:
#fixed:=[6,7,9]:

#A:=graph2perMatrix(n,G,3,fixed):
#with(LinearAlgebra):
#Permanent(A)*(1/3)^(n-3);

#graph2allBezout_3d(n, G) ;


#n:=11:
#G:=[[1, 4], [1, 5], [1, 7], [1, 10], [1, 11], [2, 5], [2, 6], [2, 8], [2, 9], [2, 10], [3, 6], [3, 7], [3, 9], [3, 11], [4, 8], [4, 10], [4, 11], [5, 7], [5, 9], [5, 10], [6, 8], [6, 9], [6, 11], [7, 9], [7, 11],  [8,10],[8, 11]]:
#fixed:=[4,8,10]:

#A:=graph2perMatrix(n,G,3,fixed):
#with(LinearAlgebra):
#Permanent(A)*(1/3)^(n-3);

#graph2allBezout_3d(n, G) ;

##Icosahedron
#G := [[1, 2], [1, 6], [1, 8], [1, 9], [1, 12], [2, 3], [2, 6], [2, 7], [2, 9], [3, 4], [3, 7], [3, 9], [3, 10], [4, 5], [4, 7], [4, 10], [4, 11], [5, 6], [5, 7], [5, 11], [5, 12], [6, 7], [6, 12], [8, 9], [8, 10], [8, 11], [8, 12], [9, 10], [10, 11], [11, 12]]:
#fixed := [1,2,6]:
#n:=12:

#A:=graph2perMatrix(n,G,3,fixed):
#with(LinearAlgebra):
#Permanent(A)*(1/3)^(n-3);

#graph2allBezout_3d(n, G) ;
















